Index: debian/changelog
===================================================================
--- debian/changelog	(revision 59767)
+++ debian/changelog	(working copy)
@@ -1,5 +1,6 @@
 cdebconf (0.146) UNRELEASED; urgency=low
 
+  [ Joey Hess ]
   * Remove newt screen clearing code. Closes: #442291
   * dpkg-reconfigure: Fix -p to set priority. Closes: #442288
   * dpkg-reconfigure: Fix skipping of seen questions. Closes: #442290
@@ -14,6 +15,13 @@
   * dpkg-reconfigure: Run prerm script to simulate package reinstallation.
     Closes: #469363
 
+  [ Colin Watson ]
+  * Add passthrough frontend, installed in the deb only since I don't think
+    the udeb needs it. This required changing the progress_start and
+    progress_info frontend methods to take the title/info as a struct
+    question * rather than a const char *; I believe this only affects
+    cdebconf-newt-terminal, which I've adjusted to cope.
+
  -- Joey Hess <joeyh@debian.org>  Sat, 18 Jul 2009 18:39:53 +0200
 
 cdebconf (0.145) unstable; urgency=low
Index: debian/rules
===================================================================
--- debian/rules	(revision 59766)
+++ debian/rules	(working copy)
@@ -15,8 +15,8 @@
 LIBDEBCONFDEV=libdebconfclient0-dev
 LIBDEBCONF=libdebconfclient0
 
-DEB_FRONTENDS=text newt gtk
-UDEB_FRONTENDS=text newt gtk
+DEB_FRONTENDS=passthrough text newt gtk
+UDEB_FRONTENDS=passthrough text newt gtk
 
 SIZEOPTFLAG=-Os
 SPEEDOPTFLAG=-O2
Index: debian/cdebconf.install
===================================================================
--- debian/cdebconf.install	(revision 59766)
+++ debian/cdebconf.install	(working copy)
@@ -6,6 +6,7 @@
 deb/usr/lib/cdebconf/debconf-dumpdb usr/lib/cdebconf
 deb/usr/lib/cdebconf/debconf-loadtemplate usr/lib/cdebconf
 deb/usr/lib/cdebconf/dpkg-reconfigure usr/lib/cdebconf
+deb/usr/lib/cdebconf/frontend/passthrough.so usr/lib/cdebconf/frontend
 deb/usr/lib/cdebconf/frontend/newt.so usr/lib/cdebconf/frontend
 deb/usr/lib/cdebconf/frontend/text.so usr/lib/cdebconf/frontend
 deb/usr/lib/cdebconf/libdebconf.so usr/lib/cdebconf
Index: configure.ac
===================================================================
--- configure.ac	(revision 59766)
+++ configure.ac	(working copy)
@@ -115,7 +115,7 @@
 dnl Frontends - which to include.
 
 if test -z "$FRONTEND_MODULES"; then
-    FRONTEND_MODULES=text
+    FRONTEND_MODULES="passthrough text"
 
     AC_CHECK_LIB([ncurses], [initscr], [FRONTEND_MODULES="$FRONTEND_MODULES ncurses"], [AC_MSG_WARN([cannot build ncurses frontend])])
     AC_CHECK_LIB([bogl], [bowl_flush], [FRONTEND_MODULES="$FRONTEND_MODULES bogl"], [AC_MSG_WARN([cannot build BOGL frontend])])
Index: src/commands.c
===================================================================
--- src/commands.c	(revision 59766)
+++ src/commands.c	(working copy)
@@ -628,7 +628,6 @@
 {
     int min, max;
     struct question *q = NULL;
-    char *value;
     char *argv[6];
     int argc;
     char *out;
@@ -658,17 +657,9 @@
                     CMDSTATUS_BADQUESTION, argv[3]);
             return out;
         }
-        value = question_get_raw_field(q, "", "description");
-        question_deref(q);
-        if (value == NULL)
-        {
-            asprintf(&out, "%u %s description field does not exist",
-                    CMDSTATUS_BADQUESTION, argv[3]);
-            return out;
-        }
         mod->frontend->methods.progress_start(mod->frontend,
-                min, max, value);
-        free(value);
+                min, max, q);
+        question_deref(q);
     }
     else if (strcasecmp(argv[0], "set") == 0)
     {
@@ -702,16 +693,8 @@
                     CMDSTATUS_BADQUESTION, argv[1]);
             return out;
         }
-        value = question_get_raw_field(q, "", "description");
+        ret = mod->frontend->methods.progress_info(mod->frontend, q);
         question_deref(q);
-        if (value == NULL)
-        {
-            asprintf(&out, "%u %s description field does not exist",
-                    CMDSTATUS_BADQUESTION, argv[1]);
-            return out;
-        }
-        ret = mod->frontend->methods.progress_info(mod->frontend, value);
-        free(value);
         if (ret == DC_GOBACK)
         {
             asprintf(&out, "%u progress bar cancelled",
Index: src/frontend.c
===================================================================
--- src/frontend.c	(revision 59766)
+++ src/frontend.c	(working copy)
@@ -200,10 +200,11 @@
 	return false;
 }
 
-static void frontend_progress_start(struct frontend *ui, int min, int max, const char *title)
+static void frontend_progress_start(struct frontend *ui, int min, int max, struct question *title)
 {
-	DELETE(ui->progress_title);
-		ui->progress_title = STRDUP(title);
+	question_deref(ui->progress_title);
+	ui->progress_title = title;
+	question_ref(ui->progress_title);
 	ui->progress_min = min;
 	ui->progress_max = max;
 	ui->progress_cur = min;
@@ -220,7 +221,7 @@
 	return ui->methods.progress_set(ui, ui->progress_cur + step);
 }
 
-static int frontend_progress_info(struct frontend *ui, const char *info)
+static int frontend_progress_info(struct frontend *ui, struct question *info)
 {
 	return DC_OK;
 }
@@ -340,7 +341,7 @@
 	DELETE(obj->capb);
 	DELETE(obj->title);
 	question_deref(obj->info);
-	DELETE(obj->progress_title);
+	question_deref(obj->progress_title);
 	DELETE(obj->plugin_path);
 	DELETE(obj);
 }
Index: src/frontend.h
===================================================================
--- src/frontend.h	(revision 59766)
+++ src/frontend.h	(working copy)
@@ -37,11 +37,11 @@
     bool (*can_cancel_progress)(struct frontend *);
     bool (*can_align)(struct frontend *, struct question *);
 
-    void (*progress_start)(struct frontend *fe, int min, int max, const char *title);
+    void (*progress_start)(struct frontend *fe, int min, int max, struct question *title);
     int (*progress_set) (struct frontend *fe, int val);
     /* You do not have to implement _step, it will call _set by default */
     int (*progress_step)(struct frontend *fe, int step);
-    int (*progress_info)(struct frontend *fe, const char *info);
+    int (*progress_info)(struct frontend *fe, struct question *info);
     void (*progress_stop)(struct frontend *fe);
    
     int (*go_noninteractive)(struct frontend *);
@@ -71,7 +71,7 @@
     char *capb;
     char *title;
     struct question *info;
-    char *progress_title;
+    struct question *progress_title;
     int progress_min, progress_max, progress_cur;
     	
     /* methods */
Index: src/modules/frontend/slang/slang.c
===================================================================
--- src/modules/frontend/slang/slang.c	(revision 59766)
+++ src/modules/frontend/slang/slang.c	(working copy)
@@ -830,17 +830,21 @@
 slang_progress_set(struct frontend *obj, int val);
 
 static void
-slang_progress_start(struct frontend *obj, int min, int max, const char *title)
+slang_progress_start(struct frontend *obj, int min, int max, struct question *title)
 {
 	struct uidata *uid = UIDATA(obj);
+	char *title_desc;
 	
-	DELETE(obj->progress_title);
-	obj->progress_title = strdup(title);
+	question_deref(obj->progress_title);
+	obj->progress_title = title;
+	question_ref(obj->progress_title);
 	obj->progress_min = min;
 	obj->progress_max = max;
 	
 	slang_drawwin(&uid->descwin);
-	slang_wrapprint(&uid->descwin, title, 0);
+	title_desc = q_get_raw_description(title);
+	slang_wrapprint(&uid->descwin, title_desc, 0);
+	free(title_desc);
 
 	slang_progress_set(obj, min);
 }
@@ -893,15 +897,19 @@
 }
 
 static int
-slang_progress_info(struct frontend *obj, const char *info)
+slang_progress_info(struct frontend *obj, struct question *info)
 {
 	struct uidata *uid = UIDATA(obj);
+	char *title_desc = q_get_raw_description(obj->progress_title);
+	char *info_desc = q_get_raw_description(info);
 	char *buf = (char *)
-		malloc(strlen(obj->progress_title) + strlen(info) + 3);
+		malloc(strlen(title_desc) + strlen(info_desc) + 3);
 	
-	strcpy(buf, obj->progress_title);
+	strcpy(buf, title_desc);
 	strcat(buf, ":\n");
-	strcat(buf, info);
+	strcat(buf, info_desc);
+	free(info_desc);
+	free(title_desc);
 	
 	slang_drawwin(&uid->descwin);
 	slang_wrapprint(&uid->descwin, buf, 0);
Index: src/modules/frontend/text/text.c
===================================================================
--- src/modules/frontend/text/text.c	(revision 59766)
+++ src/modules/frontend/text/text.c	(working copy)
@@ -918,15 +918,20 @@
 	return ret;
 }
 
-static void text_progress_start(struct frontend *obj, int min, int max, const char *title)
+static void text_progress_start(struct frontend *obj, int min, int max, struct question *title)
 {
-	DELETE(obj->progress_title);
-	obj->progress_title = STRDUP(title);
+	char *title_desc;
+
+	question_deref(obj->progress_title);
+	obj->progress_title = title;
+	question_ref(obj->progress_title);
 	obj->progress_min = min;
 	obj->progress_max = max;
 	obj->progress_cur = min;
 
-	printf("%s  ", title);
+	title_desc = q_get_raw_description(title);
+	printf("%s  ", title_desc);
+	free(title_desc);
 	fflush(stdout);
 }
 
@@ -955,7 +960,7 @@
 	INFO(INFO_DEBUG, "%s", __FUNCTION__);
 	printf("\n");
 	fflush(stdout);
-	DELETE(obj->progress_title);
+	question_deref(obj->progress_title);
 }
 
 struct frontend_module debconf_frontend_module =
Index: src/modules/frontend/gtk/progress.c
===================================================================
--- src/modules/frontend/gtk/progress.c	(revision 59766)
+++ src/modules/frontend/gtk/progress.c	(working copy)
@@ -422,11 +422,13 @@
 {
     struct frontend_data * fe_data = fe->data;
     GtkWidget * progress_bar = fe_data->progress_data->progress_bar;
+    gchar * title_desc;
 
     g_assert(NULL != progress_bar);
 
-    gtk_progress_bar_set_text(GTK_PROGRESS_BAR(progress_bar),
-                              fe->progress_title);
+    title_desc = q_get_raw_description(fe->progress_title);
+    gtk_progress_bar_set_text(GTK_PROGRESS_BAR(progress_bar), title_desc);
+    g_free(title_desc);
     gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(progress_bar),
                                   fraction /* empty progress bar */);
 }
@@ -439,7 +441,7 @@
  * @param title initial title of the operation in progress
  */
 void cdebconf_gtk_progress_start(struct frontend * fe, int min, int max,
-                                 const char * title)
+                                 struct question * title)
 {
     struct frontend_data * fe_data = fe->data;
 
@@ -461,8 +463,9 @@
 
     init_progress(fe);
 
-    g_free(fe->progress_title);
-    fe->progress_title = g_strdup(title);
+    question_deref(fe->progress_title);
+    fe->progress_title = title;
+    question_ref(fe->progress_title);
 
     update_progress_bar(fe, 0.0 /* empty */);
 
@@ -521,19 +524,22 @@
  * @param info current information about the operation in progress
  * @see progress_data#progress_label
  */
-int cdebconf_gtk_progress_info(struct frontend * fe, const char * info)
+int cdebconf_gtk_progress_info(struct frontend * fe, struct question * info)
 {
     struct frontend_data * fe_data = fe->data;
     struct progress_data * progress_data = fe_data->progress_data;
+    gchar * info_desc;
 
     if (NULL == progress_data) {
         /* called out of order */
         return DC_NOTOK;
     }
 
+    info_desc = q_get_raw_description(info);
     gdk_threads_enter();
-    gtk_entry_set_text(GTK_ENTRY(progress_data->progress_label), info);
+    gtk_entry_set_text(GTK_ENTRY(progress_data->progress_label), info_desc);
     gdk_threads_leave();
+    g_free(info_desc);
 
     if (DC_NO_ANSWER == fe_data->answer) {
         return DC_OK;
Index: src/modules/frontend/gtk/progress.h
===================================================================
--- src/modules/frontend/gtk/progress.h	(revision 59766)
+++ src/modules/frontend/gtk/progress.h	(working copy)
@@ -49,11 +49,11 @@
 bool cdebconf_gtk_can_cancel_progress(struct frontend * fe);
 
 void cdebconf_gtk_progress_start(struct frontend * fe, int min, int max,
-                                 const char * title);
+                                 struct question * title);
 
 int cdebconf_gtk_progress_set(struct frontend * fe, int val);
 
-int cdebconf_gtk_progress_info(struct frontend * fe, const char * info);
+int cdebconf_gtk_progress_info(struct frontend * fe, struct question * info);
 
 void cdebconf_gtk_progress_stop(struct frontend * fe);
 
Index: src/modules/frontend/passthrough/passthrough.c
===================================================================
--- src/modules/frontend/passthrough/passthrough.c	(revision 0)
+++ src/modules/frontend/passthrough/passthrough.c	(revision 0)
@@ -0,0 +1,393 @@
+/***********************************************************************
+ *
+ * cdebconf - An implementation of the Debian Configuration Management
+ *            System
+ *
+ * File: passthrough.c
+ *
+ * Description: Passthrough UI for cdebconf
+ *
+ * $Id$
+ *
+ * cdebconf is (c) 2000-2009 Randolph Chung and others under the following
+ * license.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ * notice, this list of conditions and the following disclaimer.
+ * 
+ * 2. Redistributions in binary form must reproduce the above copyright
+ * notice, this list of conditions and the following disclaimer in the
+ * documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ ***********************************************************************/
+#include "common.h"
+#include "commands.h"
+#include "frontend.h"
+#include "question.h"
+#include "strutl.h"
+#include "template.h"
+
+#include <stdarg.h>
+#include <errno.h>
+#include <string.h>
+#include <stdlib.h>
+#include <stdio.h>
+#include <sys/socket.h>
+#include <sys/un.h>
+
+#include "debian-installer.h"
+
+struct passthrough_data {
+    FILE *readfh, *writefh;
+};
+
+static int talk(struct frontend *obj, char **value, ...) ATTRIBUTE_SENTINEL;
+
+static int
+talk(struct frontend *obj, char **value, ...)
+{
+    struct passthrough_data *data = obj->data;
+    va_list ap;
+    char *command;
+    char buf[1023];
+    char *in;
+    size_t inlen = 0, insize = 1024;
+    char *inp, *space;
+    int ret;
+
+    if (value)
+        *value = NULL;
+
+    va_start(ap, value);
+    command = strjoinv(" ", ap);
+    va_end(ap);
+
+    INFO(INFO_DEBUG, "----> %s", command);
+    fprintf(data->writefh, "%s\n", command);
+    fflush(data->writefh);
+    free(command);
+
+    /* This is disgusting; it's more or less cloned from
+     * confmodule_communicate.
+     */
+    in = di_malloc0(insize);
+    buf[0] = 0;
+    in[0] = 0;
+    while (strchr(buf, '\n') == NULL) {
+        if (fgets(buf, sizeof(buf), data->readfh) == NULL) {
+            if (feof(data->readfh))
+                di_warning("unexpected EOF on data->readfh");
+            else
+                di_warning("read from data->readfh failed: %s", strerror(errno));
+            free(in);
+            return CMDSTATUS_INTERNALERROR;
+        }
+        if (inlen + strlen(buf) + 1 > insize) {
+            insize += sizeof(buf);
+            in = di_realloc(in, insize);
+        }
+        strcat(in, buf);
+    }
+    inp = strstrip(in);
+    INFO(INFO_DEBUG, "<---- %s", inp);
+    space = strchr(inp, ' ');
+    if (space)
+        *space = '\0';
+    ret = atoi(inp);
+    if (value) {
+        if (space)
+            *value = STRDUP(space + 1);
+        else
+            *value = STRDUP("");
+    }
+    free(in);
+    return ret;
+}
+
+static int
+passthrough_initialize(struct frontend *obj, struct configuration *cfg)
+{
+    struct passthrough_data *data;
+    const char *env_pipe = getenv("DEBCONF_PIPE");
+    const char *env_readfd = getenv("DEBCONF_READFD");
+    const char *env_writefd = getenv("DEBCONF_WRITEFD");
+
+    if (!env_pipe && (!env_readfd || !env_writefd)) {
+        di_warning("neither DEBCONF_PIPE nor DEBCONF_READFD and DEBCONF_WRITEFD were set");
+        return DC_NOTOK;
+    }
+
+    obj->interactive = 1;
+    obj->data = data = calloc(1, sizeof(struct passthrough_data));
+
+    if (env_pipe) {
+        int sock = socket(AF_UNIX, SOCK_STREAM, 0);
+        struct sockaddr_un addr;
+        if (sock < 0) {
+            di_warning("failed to create Unix-domain socket: %s", strerror(errno));
+            return DC_NOTOK;
+        }
+        memset(&addr, 0, sizeof(addr));
+        addr.sun_family = AF_UNIX;
+        strncpy(addr.sun_path, env_pipe, sizeof(addr.sun_path) - 1);
+        if (connect(sock, (struct sockaddr *) &addr, sizeof(addr)) < 0) {
+            di_warning("failed to connect Unix-domain socket to %s: %s", env_pipe, strerror(errno));
+            return DC_NOTOK;
+        }
+        data->readfh = data->writefh = fdopen(sock, "r+");
+        if (!data->readfh) {
+            di_warning("failed to open stream for Unix-domain socket connected to %s: %s", env_pipe, strerror(errno));
+            return DC_NOTOK;
+        }
+    } else {
+        data->readfh = fdopen(atoi(env_readfd), "r");
+        if (!data->readfh) {
+            di_warning("failed to open fd %s: %s", env_readfd, strerror(errno));
+            return DC_NOTOK;
+        }
+        data->writefh = fdopen(atoi(env_writefd), "w");
+        if (!data->writefh) {
+            di_warning("failed to open fd %s: %s", env_writefd, strerror(errno));
+            return DC_NOTOK;
+        }
+    }
+
+    return DC_OK;
+}
+
+static int
+passthrough_shutdown(struct frontend *obj)
+{
+    struct passthrough_data *data = obj->data;
+    if (data && data->readfh)
+        fclose(data->readfh);
+    if (data && data->writefh && data->writefh != data->readfh)
+        fclose(data->writefh);
+    free(data);
+    return DC_OK;
+}
+
+static unsigned long
+passthrough_query_capability(struct frontend *obj)
+{
+    char *capb_all, *capb_walk, *capb;
+    unsigned long ret = 0;
+
+    if (talk(obj, &capb_all, "CAPB", NULL) != 0)
+        return 0;
+    capb_walk = capb_all;
+    for (capb = strsep(&capb_walk, " "); capb;
+         capb = strsep(&capb_walk, " ")) {
+        if (strcmp(capb, "backup") == 0)
+            ret |= DCF_CAPB_BACKUP;
+        else if (strcmp(capb, "progresscancel") == 0)
+            ret |= DCF_CAPB_PROGRESSCANCEL;
+        else if (strcmp(capb, "align") == 0)
+            ret |= DCF_CAPB_ALIGN;
+    }
+    free(capb_all);
+    return ret;
+}
+
+static void
+passthrough_set_title(struct frontend *obj, const char *title)
+{
+    DELETE(obj->title);
+    obj->title = STRDUP(title);
+    /* TODO: We really ought to use SETTITLE instead, but for apparently
+     * historical reasons the frontend set_title method only gets the
+     * description.
+     */
+    talk(obj, NULL, "TITLE", title, NULL);
+}
+
+static int
+passthrough_go(struct frontend *obj)
+{
+    struct question *q;
+
+    /* TODO:
+     *   - would be nice to cache the previous value to avoid unnecessarily
+     *     resetting this
+     *   - support more capabilities than just backup
+     *   - this should be done in a proper frontend "capb" method
+     */
+    if (obj->capability & DCF_CAPB_BACKUP)
+        talk(obj, NULL, "CAPB", "backup", NULL);
+    else
+        talk(obj, NULL, "CAPB", NULL);
+
+    for (q = obj->questions; q; q = q->next) {
+        char *desc, *extdesc;
+        const char *value;
+        struct questionvariable *qv;
+
+        talk(obj, NULL, "DATA", q->tag, "type", q->template->type, NULL);
+
+        desc = q_get_description(obj, q);
+        if (desc) {
+            char *desc_esc = strreplace(desc, "\\n", "\\\\n");
+            talk(obj, NULL, "DATA", q->tag, "description", desc_esc, NULL);
+            free(desc_esc);
+            free(desc);
+        }
+
+        extdesc = q_get_extended_description(obj, q);
+        if (extdesc) {
+            char *extdesc_esc = strreplace(extdesc, "\\n", "\\\\n");
+            talk(obj, NULL, "DATA", q->tag, "extended_description",
+                 extdesc_esc, NULL);
+            free(extdesc_esc);
+            free(extdesc);
+        }
+
+        if (strcmp(q->template->type, "select") == 0 ||
+            strcmp(q->template->type, "multiselect") == 0) {
+            char *choices_c, *choices_c_esc, *choices, *choices_esc;
+
+            choices_c = question_get_field(obj, q, "C", "choices");
+            choices_c_esc = strreplace(choices_c, "\\n", "\\\\n");
+            talk(obj, NULL, "DATA", q->tag, "choices-c", choices_c_esc, NULL);
+            free(choices_c_esc);
+            free(choices_c);
+
+            choices = q_get_choices(obj, q);
+            choices_esc = strreplace(choices, "\\n", "\\\\n");
+            talk(obj, NULL, "DATA", q->tag, "choices", choices_esc, NULL);
+            free(choices_esc);
+            free(choices);
+        }
+
+        value = question_getvalue(q, "");
+        if (value && *value)
+            talk(obj, NULL, "SET", q->tag, value, NULL);
+
+        for (qv = q->variables; qv; qv = qv->next)
+            talk(obj, NULL, "SUBST", q->tag, qv->variable, qv->value, NULL);
+
+        talk(obj, NULL, "INPUT", q->priority, q->tag, NULL);
+    }
+
+    /* Tell the agent to display the question(s), and check for a back
+     * button.
+     */
+    if (obj->questions && talk(obj, NULL, "GO", NULL) == 30 &&
+        (obj->capability & DCF_CAPB_BACKUP))
+        return DC_GOBACK;
+
+    /* Retrieve the answers. */
+    for (q = obj->questions; q; q = q->next) {
+        char *value;
+        if (talk(obj, &value, "GET", q->tag, NULL) == 0) {
+            /* debconf does translation to C here, but we avoid the need for
+             * that by sending Choices-C.
+             */
+            question_setvalue(q, value);
+            INFO(INFO_DEBUG, "Got \"%s\" for %s", value, q->tag);
+        }
+        free(value);
+    }
+
+    return DC_OK;
+}
+
+static void
+progress_data(struct frontend *obj, struct question *q)
+{
+    char *desc, *extdesc;
+
+    talk(obj, NULL, "DATA", q->tag, "type", q->template->type, NULL);
+
+    desc = q_get_description(obj, q);
+    if (desc) {
+        talk(obj, NULL, "DATA", q->tag, "description", desc, NULL);
+        free(desc);
+    }
+
+    extdesc = q_get_extended_description(obj, q);
+    if (extdesc) {
+        talk(obj, NULL, "DATA", q->tag, "extended_description", extdesc, NULL);
+        free(extdesc);
+    }
+}
+
+static void
+passthrough_progress_start(struct frontend *obj, int min, int max,
+                           struct question *title)
+{
+    char *min_str, *max_str;
+
+    progress_data(obj, title);
+    asprintf(&min_str, "%d", min);
+    asprintf(&max_str, "%d", max);
+    talk(obj, NULL, "PROGRESS", "START", min_str, max_str, title->tag, NULL);
+    free(max_str);
+    free(min_str);
+}
+
+static int
+passthrough_progress_set(struct frontend *obj, int val)
+{
+    char *val_str;
+    int ret;
+
+    asprintf(&val_str, "%d", val);
+    ret = talk(obj, NULL, "PROGRESS", "SET", val_str, NULL);
+    free(val_str);
+    return ret;
+}
+
+static int
+passthrough_progress_step(struct frontend *obj, int step)
+{
+    char *step_str;
+    int ret;
+
+    asprintf(&step_str, "%d", step);
+    ret = talk(obj, NULL, "PROGRESS", "STEP", step_str, NULL);
+    free(step_str);
+    return ret;
+}
+
+static int
+passthrough_progress_info(struct frontend *obj, struct question *info)
+{
+    progress_data(obj, info);
+    return talk(obj, NULL, "PROGRESS", "INFO", info->tag, NULL);
+}
+
+static void
+passthrough_progress_stop(struct frontend *obj)
+{
+    talk(obj, NULL, "PROGRESS", "STOP", NULL);
+}
+
+struct frontend_module debconf_frontend_module =
+{
+    initialize: passthrough_initialize,
+    shutdown: passthrough_shutdown,
+    query_capability: passthrough_query_capability,
+    set_title: passthrough_set_title,
+    go: passthrough_go,
+    progress_start: passthrough_progress_start,
+    progress_set: passthrough_progress_set,
+    progress_step: passthrough_progress_step,
+    progress_info: passthrough_progress_info,
+    progress_stop: passthrough_progress_stop,
+};
Index: src/modules/frontend/passthrough/Makefile
===================================================================
--- src/modules/frontend/passthrough/Makefile	(revision 0)
+++ src/modules/frontend/passthrough/Makefile	(revision 0)
@@ -0,0 +1,5 @@
+MODULE=passthrough
+SOBJ=passthrough.so
+OBJS=passthrough.opic
+
+include ../modules.mak
Index: src/modules/frontend/newt/cdebconf_newt.h
===================================================================
--- src/modules/frontend/newt/cdebconf_newt.h	(revision 59766)
+++ src/modules/frontend/newt/cdebconf_newt.h	(working copy)
@@ -14,7 +14,7 @@
  * the main frontend struct and won't fit in the obvious place without
  * breaking the plugin ABI. Always duplicates the info string.
  */
-char *cdebconf_newt_get_progress_info(struct frontend *obj);
+struct question *cdebconf_newt_get_progress_info(struct frontend *obj);
 
 newtComponent cdebconf_newt_create_form(newtComponent scrollbar);
 
Index: src/modules/frontend/newt/newt.c
===================================================================
--- src/modules/frontend/newt/newt.c	(revision 59766)
+++ src/modules/frontend/newt/newt.c	(working copy)
@@ -71,7 +71,7 @@
                   scale_cancel,
                   perc_label;
     int           scale_textbox_height;
-    char *        scale_info;
+    struct question *scale_info;
 };
 
 struct newtColors newtAltColorPalette = {
@@ -197,13 +197,14 @@
 /* cdebconf-newt-terminal needs this in order to be able to restore the
  * display properly after tearing down the terminal.
  */
-char *
+struct question *
 cdebconf_newt_get_progress_info(struct frontend *obj)
 {
     struct newt_data *data = (struct newt_data *)obj->data;
-    if (data->scale_info)
-        return strdup(data->scale_info);
-    else
+    if (data->scale_info) {
+        question_ref(data->scale_info);
+        return data->scale_info;
+    } else
         return NULL;
 }
 
@@ -1280,12 +1281,13 @@
 }
 
 static void
-newt_make_progress_bar(struct frontend *obj, const char *info)
+newt_make_progress_bar(struct frontend *obj, struct question *info)
 {
     struct newt_data *data = (struct newt_data *)obj->data;
     int width = 80, height = 24, win_width, win_height, text_height;
     int extra = 0;
     bool can_cancel_progress;
+    char *info_desc = NULL;
     bool changed = false;
 #ifdef HAVE_LIBTEXTWRAP
     textwrap_t tw;
@@ -1302,10 +1304,14 @@
     win_width = width-7;
     if (!info)
         info = data->scale_info;
-    else
-        data->scale_info = strdup(info);
+    else {
+        data->scale_info = info;
+        question_ref(data->scale_info);
+    }
     if (info)
-        text_height = cdebconf_newt_get_text_height(info, win_width);
+        info_desc = q_get_raw_description(info);
+    if (info_desc)
+        text_height = cdebconf_newt_get_text_height(info_desc, win_width);
     else
         text_height = 0;
     /* Minimal height set to 2 to prevent box flashing */
@@ -1324,11 +1330,14 @@
         }
     }
     if (!data->scale_form || changed) {
+        char *title_desc;
         if (text_height + 3 + extra <= height - 5)
             win_height = text_height + 3 + extra;
         else
             win_height = height - 5;
-        newtCenteredWindow(win_width, win_height, obj->progress_title);
+        title_desc = q_get_raw_description(obj->progress_title);
+        newtCenteredWindow(win_width, win_height, title_desc);
+        free(title_desc);
         data->scale_bar = newtScale(TEXT_PADDING, 1, win_width-2*TEXT_PADDING, obj->progress_max - obj->progress_min);
         data->scale_textbox = newtTextbox(TEXT_PADDING, 3, win_width-2*TEXT_PADDING, text_height, flags);
         data->scale_textbox_height = text_height;
@@ -1342,21 +1351,23 @@
         newtFormSetTimer(data->scale_form, 1);
     }
     newtScaleSet(data->scale_bar, obj->progress_cur - obj->progress_min);
-    if (info) {
+    if (info_desc) {
 #ifdef HAVE_LIBTEXTWRAP
         textwrap_init(&tw);
         textwrap_columns(&tw, win_width - 2 - 2*TEXT_PADDING);
-        wrappedtext = textwrap(&tw, info);
+        wrappedtext = textwrap(&tw, info_desc);
         newtTextboxSetText(data->scale_textbox, wrappedtext);
         free(wrappedtext);
 #else
-        newtTextboxSetText(data->scale_textbox, info);
+        newtTextboxSetText(data->scale_textbox, info_desc);
 #endif
     }
+    free(info_desc);
 }
 
 static void
-newt_progress_start(struct frontend *obj, int min, int max, const char *title)
+newt_progress_start(struct frontend *obj, int min, int max,
+                    struct question *title)
 {
     struct newt_data *data = (struct newt_data *)obj->data;
 
@@ -1365,8 +1376,9 @@
          * use one anyway, tear down the old progress bar first.
          */
         newt_progress_stop(obj);
-    DELETE(obj->progress_title);
-    obj->progress_title = strdup(title);
+    question_deref(obj->progress_title);
+    obj->progress_title = title;
+    question_ref(obj->progress_title);
     obj->progress_min = min;
     obj->progress_max = max;
     obj->progress_cur = min;
@@ -1420,7 +1432,7 @@
 }
 
 static int
-newt_progress_info(struct frontend *obj, const char *info)
+newt_progress_info(struct frontend *obj, struct question *info)
 {
     struct newt_data *data = (struct newt_data *)obj->data;
     struct newtExitStruct es;
@@ -1453,7 +1465,7 @@
         newtPopWindow();
         newtFinished();
         data->scale_form = data->scale_bar = data->perc_label = data->scale_textbox = data->scale_cancel = NULL;
-        free(data->scale_info);
+        question_deref(data->scale_info);
         data->scale_info = NULL;
     }
 }
